package org.jeecg.modules.stm.rate.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rate.entity.RateDomainscore;
import org.jeecg.modules.stm.rate.service.IRateDomainscoreService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 维度分值
 * @Author: jeecg-boot
 * @Date:   2023-10-12
 * @Version: V1.0
 */

@RestController
@RequestMapping("/rate/rateDomainscore")
@Slf4j
public class RateDomainscoreController extends JeecgController<RateDomainscore, IRateDomainscoreService> {
	@Autowired
	private IRateDomainscoreService rateDomainscoreService;
	
	/**
	 * 分页列表查询
	 *
	 * @param rateDomainscore
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "维度分值-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<RateDomainscore>> queryPageList(RateDomainscore rateDomainscore,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RateDomainscore> queryWrapper = QueryGenerator.initQueryWrapper(rateDomainscore, req.getParameterMap());
		Page<RateDomainscore> page = new Page<RateDomainscore>(pageNo, pageSize);
		IPage<RateDomainscore> pageList = rateDomainscoreService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param rateDomainscore
	 * @return
	 */
	@AutoLog(value = "维度分值-添加")

	//@RequiresPermissions("rate:rate_domainscore:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RateDomainscore rateDomainscore) {
		rateDomainscoreService.save(rateDomainscore);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param rateDomainscore
	 * @return
	 */
	@AutoLog(value = "维度分值-编辑")

	//@RequiresPermissions("rate:rate_domainscore:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RateDomainscore rateDomainscore) {
		rateDomainscoreService.updateById(rateDomainscore);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "维度分值-通过id删除")

	//@RequiresPermissions("rate:rate_domainscore:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		rateDomainscoreService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "维度分值-批量删除")

	//@RequiresPermissions("rate:rate_domainscore:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.rateDomainscoreService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "维度分值-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<RateDomainscore> queryById(@RequestParam(name="id",required=true) String id) {
		RateDomainscore rateDomainscore = rateDomainscoreService.getById(id);
		if(rateDomainscore==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(rateDomainscore);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param rateDomainscore
    */
    //@RequiresPermissions("rate:rate_domainscore:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RateDomainscore rateDomainscore) {
        return super.exportXls(request, rateDomainscore, RateDomainscore.class, "维度分值");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
   // @RequiresPermissions("rate:rate_domainscore:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RateDomainscore.class);
    }

	 //@AutoLog(value = "用户分值-通过taskid查询")

	 @GetMapping(value = "/queScoreByTaskid")
	 public Result<RateDomainscore> queScoreByTaskid(@RequestParam(name="taskid",required=true) String taskid) {





		 QueryWrapper<RateDomainscore> rateDomainscoreQueryWrapper = new QueryWrapper<>();
		 rateDomainscoreQueryWrapper.select("sum(ratescore) as ratescore");

		 rateDomainscoreQueryWrapper.eq("rate_task_id",taskid);

		 RateDomainscore rateUserscore = rateDomainscoreService.getOne(rateDomainscoreQueryWrapper);

		 if(rateUserscore==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(rateUserscore);
	 }

}
